/* ipmsgsend.c	Ver.1.0
 *
 *  Jun Takahashi, Dec.,1998
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include "ipmsg.h"
#include "sendipmsg.h"

int main(int argc, char *argv[])
{
  int	i, rc;
  long	addr;
  char	hostname[64], *buf;
  struct hostent	*host;

  if(argc < 1){
    strcpy(hostname, "localhost");
  }
  else {
    strcpy(hostname, argv[1]);
  }
  addr = inet_addr(hostname);
  if(addr == -1){
    host = gethostbyname(hostname);
    if(host == NULL){
      printf("invalid hostname or IP address\n");
      exit(-1);
    }
    addr = *(long *)host->h_addr;
  }

  buf = malloc(MAX_UDPBUF);
  for(i = 0; i < MAX_UDPBUF && (buf[i] = getchar()) != EOF; i++);
  buf[i] = '\0';

  rc = sendipmsg_byinaddr(*(struct in_addr *)&addr, NULL, buf);
  if(rc != SENDIPMSG_OK){
    printf("sendipmsg error(%d)\n", rc);
    exit(rc);
  }

  free(buf);

  return 0;
}
