/* sendipmsg.c	Ver.1.0
 *
 *  Jun Takahashi, Dec.,1998
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "ipmsg.h"
#include "sendipmsg.h"

int sendipmsg_byinaddr(struct in_addr to_addr, char *from_username, char *msg)
{
  int	fd, rc;
  long	packet_no;
  char	*buf, from_hostname[64];
  struct sockaddr_in	inet_addr;

  rc = SENDIPMSG_OK;
  fd = socket(AF_INET, SOCK_DGRAM, 0);
  memset(&inet_addr, 0, sizeof(inet_addr));
  inet_addr.sin_family = AF_INET;
  inet_addr.sin_port = htons(IPMSG_DEFAULT_PORT);
  memcpy(&inet_addr.sin_addr, &to_addr, sizeof(inet_addr.sin_addr));
  if((buf = malloc(MAX_UDPBUF)) == NULL){
    rc = SENDIPMSG_MALLOC_ERROR;
  }
  else {
    gethostname(from_hostname, sizeof(from_hostname));
    packet_no = time(&packet_no)+((long)getpid() << 16);
    sprintf(buf, "%d:%ld:%s:%s:%ld:%s",
	    IPMSG_VERSION,
	    packet_no,
	    from_username == NULL ? getenv("USER") : from_username,
	    from_hostname,
	    IPMSG_SENDMSG|IPMSG_NOLOGOPT|IPMSG_NOADDLISTOPT,
	    msg == NULL ? "" : msg);
    if(sendto(fd, buf, strlen(buf)+1, 0,
	      (struct sockaddr *)&inet_addr, sizeof(inet_addr)) == -1){
      rc = SENDMSG_SEND_ERROR;
    }
    free(buf);
  }

  return rc;
}

int sendipmsg_byname(char *to_hostname, char *from_username, char *msg)
{
  int	rc;
  struct hostent	*host;

  host = gethostbyname(to_hostname);
  if(host != NULL){
    rc = sendipmsg_byinaddr(*(struct in_addr *)host->h_addr, from_username, msg);
  }
  else {
    rc = SENDIPMSG_INVALID_HOSTNAME;
  }
  return rc;
}

int sendipmsg_byipaddr(char *to_ipaddr, char *from_username, char *msg)
{
  int	rc;
  long	addr;

  addr = inet_addr(to_ipaddr);
  if(addr == -1){
    rc = SENDIPMSG_INVALID_IPADDRESS;
  }
  else {
    rc = sendipmsg_byinaddr(*(struct in_addr *)&addr, from_username, msg);
  }
  return rc;
}
